        @library        fargoc
        include         macros2.h
; ***************************************************
; ************THE FARGO COMMUNAL LIBRARY*************
;
;            V E R S I O N  2 . 00 . 00
;
; Maintained by Tim Gerla, timg@climax.polaristel.net
; Please send any submissions to the above address.
;
; All code Copywrite (C) 1997 respective authors.
; ALL RIGHTS RESERVED
;
; By submitting code to this library you accept that
; other authors may use your code AS IS in this library,
; please use this library like any other Fargo library.
; For example, FLIB.
;
; Please, someone write a better disclamer/copywrite/
; legal notice. I'm not a laywer, so it's probably all
; wrong. :)
;
; Please report any errors to timg@climax.polaristel.net.
;
; DO NOT MODIFY THIS LIBRARY AND RELEASE IT AGAIN. IF
; YOU WOULD LIKE TO MAKE AN ADDITION, PLEASE SEND IT TO
; ME, THE MAINTAINER, FIRST. Thanks.
;
; Note: The new version of this library was placed together
; by Kyle Stemen (Blue_ligh on IRC), with the permission of
; Tim Gerla. Please sent any complaints about my functions
; to me at blue-lightning@usa.net.
;
;************** Start of Fargo library ***************

;---contrast_up, by Tim Gerla timg@climax.polaristel.net
;
        label           contrast_up
        movem.l d0-d1/a0,-(a7)          ;push regs
        move.w          #09,d0          ;load call
        trap            #9              ;trap #9
        jsr             (a0)            ;jump to rom
        movem.l (a7)+,d0-d1/a0          ;pop regs
        rts                             ;return
;*****************************************************
;---contrast_down, by Tim Gerla <timg@climax.polaristel.net>
;
        label           contrast_down   ;see above
        movem.l d0-d1/a0,-(a7)          ;"
        move.w          #10,d0          ;"
        trap            #9              ;"
        jsr             (a0)            ;"
        movem.l (a7)+,d0-d1/a0          ;"
        rts


;*****************************************************
;---ver, by Christopher Poole <poole.christopher@paradox.net>
;
        label           ver
        movem.l         d1-d7/a0-a6,-(a7)       ;push regs
        move.l          d0,d1                   ;hold requested v#
        move.l          comunal_ver,d0          ;move ver to d0
        cmp             d0,d1                   ;check for requested v#
        ble             will_work               ;will work? goto finish
        jsr             flib[clr_scr]           ;clear screen
        setfont         #2                      ;set the font
        writestr        #10,#10,#2,old_lib1     ;print error text
        writestr        #10,#20,#2,old_lib2     ;print error text
        setfont         #1                      ;set the font
        writestr        #10,#40,#2,please1      ;print error text
        writestr        #10,#50,#2,please2      ;print error text
        writestr        #10,#70,#2,webpage      ;print error text
        writestr        #10,#80,#2,webpage2      ;print error text
        jsr             flib[idle_loop]         ;wait for keypress
        move.l          #0,d0                   ;return error
will_work:                                      ;good!
        movem.l         (a7)+,d1-d7/a0-a6       ;pop regs
	rts
;*****************************************************
;---upcontrast, by J. Kristian K. Nielsen <jkkn@ctav.com>
;
	label		upcontrast
	cmp.w		#0,d0
	beq		c_end
	sub.w		#1,d0
upc:
	bsr		contrast_up
	dbf		d0,upc
c_end:
	rts

;*****************************************************
;---downcontrast, by J. Kristian K. Nielsen <jkkn@ctav.com>
;
	label		downcontrast
	cmp.w		#0,d0
	beq		c_end
	sub.w		#1,d0
downc:
	bsr		contrast_down
	dbf		d0,downc
	rts

;*****************************************************
;---getcontrast, by J. Kristian K. Nielsen <jkkn@ctav.com>
;
	label		getcontrast
	move.b		($5340),d1
	rts

;*****************************************************
;---setcontrast, by J. Kristian K. Nielsen <jkkn@ctav.com>
;
	label		setcontrast
	move.b		d1,d0
	bsr		getcontrast
	cmp.b		d0,d1
	bgt		c_down
	sub.b		d1,d0
	move.b		d0,d1
	bsr		upcontrast
	bra		set_end
c_down:
	sub.b		d0,d1
	bsr		downcontrast
set_end:
	rts

;*****************************************************
;---delay, by J. Kristian K. Nielsen <jkkn@ctav.com>
;					- version .5beta
	label		delay
delay_loop:
	dbf		d7,delay_loop
	rts

;*****************************************************
;---fadedown, by J. Kristian K. Nielsen <jkkn@ctav.com>
;
	label		fadedown
        movem.l         d0-d7/a0-a6,-(a7)       ;push regs
	bsr		getcontrast
	move.b		d1,savecontrast
faded_loop:
	bsr		contrast_down
	move.w		#$8000,d7
	bsr		delay
	bsr		getcontrast
	cmp.b		#1,d1
	bne		faded_loop

	cmp.b		#1,d2
	bne		faded_end
	move.b		savecontrast,d1
	bsr		setcontrast
faded_end:
        movem.l         (a7)+,d0-d7/a0-a6       ;pop regs
	move.b		savecontrast,d2
	rts

;*****************************************************
;---fadeup, by J. Kristian K. Nielsen <jkkn@ctav.com>
;
	label		fadeup
        movem.l         d0-d7/a0-a6,-(a7)       ;push regs
	bsr		getcontrast
	move.b		d1,savecontrast
fadeu_loop:
	bsr		contrast_up
	move.w		#$8000,d7
	bsr		delay
	bsr		getcontrast
	cmp.b		#$18,d1
	bne		fadeu_loop

	cmp.b		#1,d2
	bne		fadeu_end
	move.b		savecontrast,d1
	bsr		setcontrast
fadeu_end:
        movem.l         (a7)+,d0-d7/a0-a6       ;pop regs
	move.b		savecontrast,d2
	rts

;*****************************************************
;---put_grayscale_pixel, by Jonas Minnberg <md94-jmi@nada.kth.se>
;
        label   put_grayscale_pixel
        movem.l         d1-d7/a1-a6,-(a7)       ;push regs
        move.w  d0,d4
        move.w  d1,d5
        lea     $4440,a0                ;First bitplane
        btst    #1,d3                   ;Test bit 1 in colorvalue to see if
        beq.s   \cpix0                  ;we should set or clear this pixel
        bsr     set_pixel
        bra.s   \done0
\cpix0:
        bsr     clr_pixel
\done0:
        move.w  d4,d0
        move.w  d5,d1
        move.l  a4,a0           ;Second bitplane
        btst    #0,d3                   ;Test bit 0 in colorvalue to see if
        beq.s   \cpix1                  ;we should set or clear this pixel
        bsr     set_pixel
        bra.s   \done1
\cpix1:
        bsr     clr_pixel
\done1:
        movem.l         (a7)+,d1-d7/a1-a6       ;pop regs
        rts

;Clear Pixel
;A0.L = bitplane, D0.W = X position, D1.W = Y position
;Destroys D0-D2
clr_pixel:                      ;(INTERNAL ROUTINE)
        bsr     calc_offset
        bclr.b  d2,0(a0,d1)
        rts

;Set Pixel                      ;(INTERNAL ROUTINE)
;A0.L = bitplane, D0.W = X position, D1.W = Y position
;Destroys D0-D2
set_pixel:
        bsr     calc_offset
        bset.b  d2,0(a0,d1)
        rts

calc_offset:                    ;(INTERNAL ROUTINE)
        add.w   d1,d1           ;Multiply Y coordinate by 30
        move.w  d1,d2           ;without MUL instruction
        lsl.w   #4,d1           ;(32*Y-2*Y)
        sub.w   d2,d1           ;Only shifts and adds

        move.b  d0,d2
        eor.b   #$7,d2
        lsr.b   #3,d0
        add.w   d0,d1           ;D1 Now holds offset to byte
        rts

;*****************************************************
;---case, by Christopher Poole <poole.christopher@paradox.net>
;
;-----
	label		case
        movem.l         d1-d7/a1-a6,-(a7)       ;push regs
next_letter:
	move.b		(a0),d1
	;start to see what the character is
	cmp		#0,d1
	beq		done_string	;0 is the ending of string
	cmp		#32,d1
	beq		is_space	;is it a space?
	cmp		#65,d1
	blt		done_switch	;no "letters" below 65
	cmp		#90,d1
	ble		is_upper	;65-90 are uppercase
	cmp		#97,d1
	blt		done_switch	;no lowercase below 97
	cmp		#122,d1
	ble		is_lower	;97-122 are lowercase
	cmp		#192,d1
	blt		done_switch	;no "accent letters" below 192
	cmp		#215,d1
	beq		done_switch	;non letter (multiply sign)
	cmp		#247,d1
	beq		done_switch	;non letter (divide sign)
	cmp		#221,d1
	ble		is_upper	;192-221 are uppercase accent
	cmp		#224,d1
	blt		done_switch	;no lowercase below 97
	cmp		#253,d1
	ble		is_lower	;224-253 are lowercase accent
	;start to process the character
done_switch: ;either the character isn't letter or done changing cases
	move.b		#0,d2		;clear space register
done_space:
        move.b          d1,(a0)+        ;replace char and go to next
	bra		next_letter	;goto change next char
is_space:
	move.b		#1,d2		;load space register	
	bra		done_space

is_lower:
	cmp		#0,d0
	beq		done_switch	;already lowercase
	cmp		#1,d0
	beq		sub32		;subtract 32 to make it uppercase
	cmp		#2,d0
	beq		sub32		;subtract 32 to make it inverse
	cmp		#1,d2		;is space register set (title)
	beq		sub32		;subtract 32 to make it title
	bra		done_switch

is_upper:
        cmp             #0,d0
	beq		add32		;add 32 to make it lowercase
	cmp		#1,d0
	beq		done_switch	;already uppercase
	cmp		#2,d0
	beq		add32		;add 32 to make it inverse
	cmp		#0,d2		;is space register unset (title)
	beq		add32		;add 32 to make it title
	bra		done_switch

sub32:
	sub		#32,d1		;add 32 to make it lowercase
	bra		done_switch

add32:
	add		#32,d1		;add 32 to make it uppercase
	bra		done_switch

done_string:
        movem.l         (a7)+,d1-d7/a1-a6       ;pop regs
	rts		

;*****************************************************
;---input_string, by Kyle Stemen <blue-lightning@usa.net>
;
;-----
	label	input_string
	move.l	a0,a1
	lea	_x,a0
	move.w	d0,(a0)
	lea	_y,a0
	move.w	d1,(a0)
	move.w	#0,d1
	lea	_rbuf(PC),a0
	movem.l	d0-d2/a1,(a0)
	SetFont	#1
	movem.l	_rbuf(PC),d0-d2/a1
inp_loop_begin:
	clr.l	d0
	lea	_rbuf(PC),a0
	movem.l	d0-d2/a1,(a0)
	WriteChar _x,#1,#4,#95
	movem.l	_rbuf(PC),d0-d2/a1
	jsr	flib[idle_loop]
	cmp.w	#13,d0
	beq	inp_loop_end
	cmp.w	#257,d0
	bne	inp_loop_p3
	sub.w	#1,d1
	sub.l	#1,a1
	sub.w	#6,_x
	cmp.w	#0,d1		;Will cut this out soon
	bge	inp_loop_p2
	add.w	#6,_x
	add.l	#1,a1
	move.w	#0,d1
inp_loop_p2:
	lea	_rbuf(PC),a0
	movem.l	d0-d2/a1,(a0)
	add.w	#6,_x
	WriteChar _x,_y,#4,#32
	sub.w	#6,_x
	movem.l	_rbuf(PC),d0-d2/a1
	bra	inp_loop_begin
inp_loop_p3:
	move.w	d1,d3
	add.w	#1,d3
	cmp.w	d3,d2
	blt	inp_loop_begin
	move.b	d0,(a1)
	add.l	#1,a1
	lea	_rbuf(PC),a0
	movem.l	d0-d2/a1,(a0)
	WriteChar _x,_y,#4,d0
	movem.l	_rbuf(PC),d0-d2/a1
	add.w	#1,d1
	add.w	#6,_x
	bra	inp_loop_begin	;Restart the loop

inp_loop_end:
	move.b	#0,(a1)
	sub.l	#1,a1
	rts

;*****************************************************
;---enter_hex_digit, by Kyle Stemen <blue-lightning@usa.net>
;
;-----
	label	enter_hex_digit
enter_hex_digitl:
	jsr	flib[idle_loop]	;Get a key
	cmp.w	#48,d0		;Check if it has a scancode less than that of 0
	blt	enter_hex_digitl
	cmp.w	#102,d0		;Check if it has a scancode larger than that of f
	bgt	enter_hex_digitl
	cmp.w	#58,d0		;Make sure its scancode isn't smaller than 0's
	blt	number

	cmp.w	#97,d0		;Make sure its scancode isn't larger than F's
	blt	enter_hex_digitl
	cmp.w	#102,d0
	bgt	enter_hex_digitl
	sub.w	#39,d0		;Make it so with the "number subtract" it will have the value right
	;value
number:
	sub.w	#48,d0		;Turn the scancode into a normal value
	rts

;*****************************************************
;---enter_hex_num, by Kyle Stemen <blue-lightning@usa.net>
;
;-----
	label	enter_hex_num
	lea	_x(PC),a0
	move.w	d0,(a0)
	lea	_y(PC),a0
	move.w	d1,(a0)
	sub.w	#1,d2
	muls	#4,d2
	lea	_maxd(PC),a1
	move.w	d2,(a1)
	lea	_d(PC),a0
	clr.w	(a0)
	moveq.w	#0,d3
	lea	_d(PC),a0
enter_value:
	lea	_i(PC),a0
	move.w	d3,(a0)
	bsr	enter_hex_digitl
	move.l	d0,d2
	clr.l	d4
	move.w	_maxd(PC),d4
	sub.w	d3,d4
	lsl.l	d4,d2
	lea	_d(PC),a0
	add.w	d2,(a0)

	add.w	_x(PC),d3
	move.w	d0,-(a7)
	printf	d3,_y(PC),form1(PC),strbuf(PC),#2	;Display it on the screen
	move.w	_i(PC),d3
	addi	#4,d3
	move.w	_maxd(PC),d4
	cmp.w	d4,d3	;Max num used here
	ble	enter_value
	move.w	_d(PC),d0
	rts

;*****************************************************
;---strlen0, by Kyle Stemen <blue-lightning@usa.net>
;
;-----
	label	strlen0
	lea	sizes(PC),a1
	move.b	(a0),d0
csizel:				;check size loop
	move.l	a1,a2
	add.l	d0,a2
	move.b	(a2),d2
	add.w	d2,d1
	add.l	#1,a0
	move.b	(a0),d0
	cmp.b	#0,d0
	bne	csizel
	move.w	d1,d0
	rts

;*****************************************************
;---strlen1, by Kyle Stemen <blue-lightning@usa.net>
;
;-----
	label	strlen1
	bsr	lstrlen
	muls	#6,d0
	rts

;*****************************************************
;---strlen2, by Kyle Stemen <blue-lightning@usa.net>
;
;-----
	label	strlen2
	bsr	lstrlen
	muls	#8,d0
	rts

;*****************************************************
;---strlen, by Kyle Stemen <blue-lightning@usa.net>
;
;-----
	label	strlen
lstrlen:
	clr.l	d1
	move.b	(a0),d0
csizel2:				;check size loop
	addq.w	#1,d1
	add.l	#1,a0
	move.b	(a0),d0
	cmp.b	#0,d0
	bne	csizel2
	move.w	d1,d0
	rts

;*************** DATA ********************************

comunal_ver             dc.l    20000               ; 2.00.00

old_lib1 dc.b           "This program requires",0
old_lib2 dc.b           "a newer FargoC library.",0
please1  dc.b           "Please see the this web page",0
please2  dc.b           "for the latest version:",0
webpage  dc.b           "http://www.geocities.com/SiliconValley",0
webpage2 dc.b           "/Park/1691/68k.html",0

savecontrast	dc.b	0

;*****************************************************
;Used for Kyle Stemen's functions
strbuf	dc.l	0,0,0,0,0,0,0,0 ;buffer for displaying numbers
_rbuf	ds.l	4
_x	dc.w	0
_y	dc.w	0
_d	dc.w	0
_maxd	dc.w	0
_i	dc.w	0
form1	dc.b	"%X",0		;format for displaying numbers
sizes	dc.b	0,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4;0-15	;This is the
	dc.b	4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4;16-31	;table for
	dc.b	2,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4;32-47	;strlen0. The
	dc.b	4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4;48-63	;numbers are the
	dc.b	4,4,4,4,4,4,4,5,4,2,4,5,4,6,5,4;64-79	;size of that
	dc.b	4,5,4,4,4,4,4,6,4,4,4,4,4,4,4,4;80-95	;char.
	dc.b	4,4,4,4,4,4,3,4,4,2,4,4,3,6,4,4;96-111
	dc.b	4,4,4,3,3,4,4,6,4,4,5,4,4,4,4,4;112-127
	dc.b	4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4;128-143
	dc.b	4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4;144-159
	dc.b	4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4;160-175
	dc.b	4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4;176-191
	dc.b	4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4;192-207
	dc.b	4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4;208-223
	dc.b	4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4;224-239
	dc.b	4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4;240-255
;*************** End of Fargo library ****************

	reloc_open
	add_library	romlib
        add_library     flib
	reloc_close
	end
